/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;// 定义了一个抽象类 Node

import android.database.Cursor;

import org.json.JSONObject;

public abstract class Node {// 定义了一些静态变量
    public static final int SYNC_ACTION_NONE = 0;

    public static final int SYNC_ACTION_ADD_REMOTE = 1;

    public static final int SYNC_ACTION_ADD_LOCAL = 2;

    public static final int SYNC_ACTION_DEL_REMOTE = 3;

    public static final int SYNC_ACTION_DEL_LOCAL = 4;

    public static final int SYNC_ACTION_UPDATE_REMOTE = 5;

    public static final int SYNC_ACTION_UPDATE_LOCAL = 6;

    public static final int SYNC_ACTION_UPDATE_CONFLICT = 7;

    public static final int SYNC_ACTION_ERROR = 8;// 定义了一些实例变量
    private String mGid;

    private String mName;

    private long mLastModified;

    private boolean mDeleted;

    public Node() {// 构造函数，初始化实例变量
        mGid = null;
        mName = "";
        mLastModified = 0;
        mDeleted = false;
    }

    public abstract JSONObject getCreateAction(int actionId);// 抽象方法，获取创建操作的 JSONObject 对象

    public abstract JSONObject getUpdateAction(int actionId);// 抽象方法，获取更新操作的 JSONObject 对象

    public abstract void setContentByRemoteJSON(JSONObject js);// 抽象方法，根据远程服务器上的 JSON 对象设置节点的内容

    public abstract void setContentByLocalJSON(JSONObject js);// 抽象方法，根据本地 JSON 对象设置节点的内容

    public abstract JSONObject getLocalJSONFromContent();// 抽象方法，从内容中获取本地 JSON 对象

    public abstract int getSyncAction(Cursor c);// 抽象方法，获取同步操作类型

    public void setGid(String gid) {// 设置、获取实例变量 mGid
        this.mGid = gid;
    }

    public void setName(String name) {// 设置、获取实例变量 mName
        this.mName = name;
    }

    public void setLastModified(long lastModified) {// 设置、获取实例变量 mLastModified
        this.mLastModified = lastModified;
    }

    public void setDeleted(boolean deleted) {// 设置、获取实例变量 mDeleted
        this.mDeleted = deleted;
    }

    public String getGid() {
        return this.mGid;
    }

    public String getName() {
        return this.mName;
    }

    public long getLastModified() {
        return this.mLastModified;
    }

    public boolean getDeleted() {
        return this.mDeleted;
    }

}
